您的位置:首页 > Web前端 > JavaScript

poj3255 dijsktra求次短路经

2015-02-19 12:42 211 查看
如题:http://poj.org/problem?id=3255

Roadblocks

Time Limit: 2000MSMemory Limit: 65536K
Total Submissions: 8192Accepted: 2984
Description

Bessie has moved to a small farm and sometimes enjoys returning to visit one of her best friends. She does not want to get to her old home too quickly, because she likes the scenery along the way. She has decided to take the second-shortest rather than the
shortest path. She knows there must be some second-shortest path.

The countryside consists of R (1 ≤ R ≤ 100,000) bidirectional roads, each linking two of the N (1 ≤
N ≤ 5000) intersections, conveniently numbered 1..N. Bessie starts at intersection 1, and her friend (the destination) is at intersection
N.

The second-shortest path may share roads with any of the shortest paths, and it may backtrack i.e., use the same road or intersection more than once. The second-shortest path is the shortest path whose length is longer than the shortest path(s) (i.e., if
two or more shortest paths exist, the second-shortest path is the one whose length is longer than those but no longer than any other path).

Input
Line 1: Two space-separated integers: N and
R

Lines 2..R+1: Each line contains three space-separated integers: A,
B, and D that describe a road that connects intersections A and
B and has length D (1 ≤ D ≤ 5000)
Output
Line 1: The length of the second shortest path between node 1 and node
N
Sample Input
4 4
1 2 100
2 4 200
2 3 250
3 4 100

Sample Output
450

Hint
Two routes: 1 -> 2 -> 4 (length 100+200=300) and 1 -> 2 -> 3 -> 4 (length 100+250+100=450)
Source
USACO 2006 November Gold




题目很简单,给出一个无向图,求出源点1到V的次短路经。

思路:到顶点v的次短路经要不就是1到某个其他顶点u的最短路+u->v的那条边,或者是到u的次短路+u->v的那条边。因此在维护队列的同时,同时维护最短路和次短路经即可。



#include<iostream>

#include<cstdio>

#include<cstring>

#include<vector>

#include<queue>

using namespace std;

#define MAXV 5005

#define INF 0x0fffffff

int V,E;

struct edge

{

int to,cost;

edge(){}

edge(int a,int b):to(a),cost(b){}

};

vector<edge>G[MAXV];

int dist1[MAXV];

int dist2[MAXV];

typedef pair<int,int>P; //距离,顶点

class cmp

{

public:

bool operator()(P &a,P &b)

{

return a.first>b.first;

}

};

void solve()

{

priority_queue<P,vector<P>,cmp>que;

fill(dist1,dist1+MAXV,INF);

fill(dist2,dist2+MAXV,INF);

dist1[1]=0;

que.push(P(0,1));

while(!que.empty())

{

P p=que.top();

que.pop();

int v=p.second;

int d=p.first;

if(d>dist2[v])

continue;

int i;

for(i=0;i<G[v].size();i++)

{

edge e=G[v][i];

int d2=d+e.cost;

if(dist1[e.to]>d2)

{

swap(dist1[e.to],d2);

que.push(P(dist1[e.to],e.to));

}

if(dist1[e.to]<d2&&dist2[e.to]>d2)

{

dist2[e.to]=d2;

que.push(P(dist2[e.to],e.to));

}

}

}

}

int main()

{

scanf("%d%d",&V,&E);

int i;

for(i=0;i<E;i++)

{

int a,b,c;

scanf("%d%d%d",&a,&b,&c);

G[a].push_back(edge(b,c));

G[b].push_back(edge(a,c));

}

solve();

cout<<dist2[V]<<endl;

return 0;

}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: